#!/bin/sh

export TEXTDOMAIN="app-helper"
export TEXTDOMAINDIR="/usr/share/locale"
user=$(ps aux | awk '{print $1" "$11}' | sed -e 's|root.*||'| grep -v sddm |grep dbus-launch | awk '{print $1}' | sed 's|+||')

longname=$(users | grep ${user} | sed 's/root //'| awk '{print $1}')
[ "x$longname" = "x" -a "x$longname" = " " ]&&longname=$user

if [ "$(echo $longname |grep '^[a-zA-Z]')" = "" ];then
    echo "Not named user, get from group id"
    usernum=`echo "$longname" | grep '^[0-9]'`
    for anuser in `cat /etc/group | grep "$usernum" | awk -F: '{ print $1}'` ;do 
	users="$anuser $(echo "$longname" | sed "s|$usernum||" | uniq)"
    done
 else
    echo "[ ------ Great this this a named user --------- ] [$longname]"
    users=$longname
fi 
sleep 1
export PATH=/usr/lib/blackPanther-default-apps/bin:$PATH
export DISPLAY=:0

if [ "$1" = "-u" ];then
echo -n "Find Removable App-Helper Items : "
find /usr/share/applications/ -type f \( ! -name "*.*" -o -name "*.desktop" ! -name "*app-helper.desktop" \) | while read Line ;do
    path=$(dirname "${Line}")
    filename=$(basename "${Line}")
    helper=$(cat "$path/$filename"| grep app-helper)
    if [ -n "$helper" -a -f "$path/$filename" ];then
	[ "$1" = "DEBUG" ]&&echo 
	[ "$1" = "DEBUG" ]&&echo "Removed app-helper Item: $path/$filename"
	rm -f $path/$filename
    fi
    echo -n "#"
done
echo ' [done]'
exit
fi

[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i system-search -t 10000 '$(gettext "App-Helper Preparing..")' '$(gettext "Search and clean older App-Helper items. Please wait! Do not restart the computer while running!")'" $users

#echo -n "Clean older App-Helper Items : "
#IFS=$'\n'
#for i in `find /usr/share/applications -type f \( ! -name "*.*" -o -name '*.desktop' ! -name "*app-helper.desktop" \)`; do
#    HELPER=$(cat "$i" | grep "app-helper ")
#    if [ "x" != "x$HELPER" ];then
#	[ -f "$i" ]&&rm -f "$i" && echo "Deleted: $i"
#    fi
#    echo -n "#"
#done
#echo " [done]"


echo -n "[ ------ Find Installable App-Helper Items ---- ]"
IFS=$'\n'
[ ! -d /usr/share/applications/kde4 ] && mkdir -p /usr/share/applications/kde4
for app in $(find /usr/share/bP/app-helper/ -name "*.desktop") ; do 
    appname=`cat $app | grep ^Exec= |head -n 1| awk '{ print $3 }' | sed 's|).*||' 2>/dev/null`
    deskfile=$(find /usr/share/applications -name `echo $app| sed 's|/usr/share/bP/app-helper/||'`)
    [ "$1" = "DEBUG" ]&&echo
    [ "$1" = "DEBUG" ]&&echo "$app - $appname - $deskfile"
    if [ -n "$app" ]&&[ ! -n "$deskfile" ];then
	[ "$1" = "DEBUG" ]&&echo "App: $app Add"
	    #for chk in $(find /usr/share/applications -name "*.desktop") ; do 
	#	[ "$1" = "DEBUG" ]&&echo -n "."
	#	appchk=$(cat "$chk" | grep "Exec=$appname")
	#	if [ "x$appchk" != "x" ];then 
	#	    FOUND=1
	#	    [ "$1" = "DEBUG" ]&&echo "-"
	#	    echo
	#	    echo "Skip! The \"$appname\" in $app conflict with $chk"
	#	    echo
	#	    sleep 10
	#	fi
	#    done
	    [ ! -n "$deskfile" ]&&deskfile=$(echo $app| sed 's|/bP/app-helper|/applications|')
	    [ "$1" = "DEBUG" ]&&echo "cp -f $app - $deskfile"
	    [ ! -n "$FOUND" ]&& cp -f "$app" "$deskfile"
	else
	    [ "$1" = "DEBUG" ]&&echo "Skipped: The $deskfile already exists"
    fi
    #echo -n "#"
done

echo " [done]"

[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i view-refresh -t 30000 '$(gettext "App-Helper Setup")' '$(gettext "Looking for available applications. Please wait! Do not restart the computer while running!")'" $users

echo -n "[ ------ Find UnStored App-Helper Items ------- ]"
sleep 1
for i in `find /usr/share/applications -type f \( ! -name "*.*" -o -name '*.desktop' ! -name "*app-helper.desktop" ! -name "*teamviewer*.desktop" \)`; do
    #[ "$1" = "DEBUG" ]&&echo "App: $i"
    HELPER=$(cat "$i" | grep "app-helper ")
    if [ "x" != "x$HELPER" ];then
    [ "$1" = "DEBUG" ]&&echo
     appname=`cat $i | grep ^Exec= | awk '{ print $3 }' | sed 's|).*||' | head -n 1 2>/dev/null`
     [ "$1" = "DEBUG" ]&&echo "AppName: $appname"
     deskfile=$(perl /usr/bin/urpmq -l $appname 2>/dev/null | grep applications/ | grep '.desktop$'| grep "$appname" | head -n 1)
     [ "$1" = "DEBUG" ]&&echo -n "Deskfile: $deskfile"
     if [ ! -n "$deskfile" ];then
	deskfile=$(perl /usr/bin/urpmq -l $appname 2>/dev/null | grep applications/ | grep '.desktop$'| head -n 1 2>/dev/null)
	[ "$1" = "DEBUG" ]&&echo -n "-- $deskfile"
     fi
     if [ -n "$appname" ]&&[ ! -n "$deskfile" ];then
	[ "$1" = "DEBUG" ]&&echo "$i [ * Removed * ]"
	[ -f "$i" ]&& rm -f $i
	else
	#[ "$1" = "DEBUG" ]&& echo
	[ "$1" = "DEBUG" ]&& echo " [ Stored! ]"
     fi
    fi
done
echo " [done]"

[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i system-help -t 10000 '$(gettext "App-Helper Checking")' '$(gettext "Installed items double check.. Please wait a little bit! Almost Ready, do not restaring!")'" $users

echo -n "[ ------ Find and Fix Sercvicemenu items ------ ]"

find /usr/share/kservices5/ServiceMenus -type f \( ! -name "*.*" -o -name "*.desktop" ! -name "*app-helper.desktop" \) | while read Line
do
    path=$(dirname "${Line}")
    filename=$(basename "${Line}")
    helper=$(cat "$path/$filename"| grep ^Exec=app-helper)
    if [ -n "$helper" ];then
	APP=$(echo $helper | awk '{print $2}') 
	[ "$1" = "DEBUG" ]&&echo "Removed app-helper Item: $path/$filename $APP"
	sed -i -e "s|Exec=app-helper .*|Exec=sh \"\$(/usr/bin/app-helper $APP)\"|" $path/$filename
    fi
    [ "$1" = "DEBUG" ]&&echo -n "#"
done

echo -n " [done]"
echo

[ -n "$DISPLAY" ]&&su -c "notify-send -u normal -i security-high -t 16000 '$(gettext "App-Helper Done!")' '$(gettext "Available applications are installed to Your menu!")'" $users

# broken kate icon
[ ! -x /usr/bin/kate ]&& rm -f /usr/share/applications/kde/*kate*.desktop 2 >/dev/null

# broken krusader
[ ! -x /usr/bin/krusader ]&& rm -f /usr/share/applications/kde/*krusader*.desktop 2 >/dev/null

